<template>
  <mdb-container id=form>
    <mdb-row class="justify-content-center">
      <mdb-col col="12" md="8" lg="6">
  <form id=cont novalidate @submit="checkForm">
    <h2 class="h1-responsive text-center mb-4">Upload Your Image</h2>

    <!-- Default input name -->
    <label for="defaultFormContactNameEx" >Your name</label>
    <input type="text" id="defaultFormContactNameEx" class="form-control"  v-model="name" required>

    <br>

    <!-- Default input email -->
    <label for="defaultFormContactEmailEx" >Your email <br><span style="font-weight:bold" >!!!BE SURE THAT YOUR ADDRESS IS CORRECT!!!</span></label>
    <input type="email" id="defaultFormContactEmailEx" class="form-control" v-model="email" required >

    <br>

    <label for="defaultFormContactMessageEx">What do you want us to do with your image</label>
    <textarea type="text" id="defaultFormContactMessageEx" class="form-control" rows="3" v-model="message"  :disabled="!email" placeholder="For example: Keep the drawing, only change the background." required></textarea>

    <br>
    <!-- Default input subject -->
    <label for="defaultFormContactSubjectEx" > Choose file</label>
    <input type="file" id="defaultFormContactSubjectEx" class="form-control" ref="file"  @change="onFileChange"  :disabled="!email" required>

    <br>
<div class= "area" v-if="!image">
    <div class="imagearea"></div>
</div>
<div v-else>
    <img  :src="image" class="img-fluid" alt="Responsive image">
</div>
<br>
<div class="custom-control custom-checkbox">
      <input type="checkbox" class="custom-control-input" id="defaultUnchecked" v-model="checked">
      <label class="custom-control-label" for="defaultUnchecked">I accept the terms and conditions</label>
  </div>
  
    <div class="text-center mt-4">
        <button class="btn btn-outline-info" type="submit" :disabled="!checked" @click="sendData">Send<i class="far fa-paper-plane ml-2"></i> </button>
    </div>
    <div class="text-center" v-if="loading">
    <div class="spinner-border" role="status">
    </div>
    <p>This process can take a while, please wait!</p>
  </div>
  </form>
      </mdb-col>
    </mdb-row> 
  </mdb-container><!-- Default form contact -->
</template>
<script>
  import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
  import {fb,db} from "./firebase";
  export default {
      data() {
            return {
                checked : false,
                image: null,
                name:null,
                email: '',
                file:null,
                message:null,
                loading: false
            }
            
        },
    components: {
      mdbContainer,
      mdbRow,
      mdbCol
    },
    methods: {
      checkForm(event) {
        event.preventDefault();
        event.target.classList.add('was-validated');
      },
      onFileChange(e) {
                let file = e.target.files[0];

                var storageRef = fb.storage().ref("drawings/"+file.name+ " " + this.email);

                storageRef.put(file);

                console.log(e.target.files[0]);
                var files = e.target.files || e.dataTransfer.files;
                if (!files.length)
                    return;
                this.createImage(files[0]);
                this.file = this.$refs.file.files[0];

            },
            createImage(file) {
                var image = new Image();
                var reader = new FileReader();
                var vm = this;

                reader.onload = (e) => {
                    vm.image = e.target.result;
                };
                reader.readAsDataURL(file);
            },
            sendData(){
              this.loading=true;
              if (this.name != null, this.email != '', this.image != null, this.message != null){
        this.$http.post('https://mdb-drawill.firebaseio.com/upload.json', {name: this.name,email: this.email,file: this.file, image: this.image, message: this.message})
        .then((response)=>{
          console.log(response);
          alert("Successfully Uploaded");
          this.reset();
        })
       }
       else {
          alert("Please fill all the fields")
        }
      },
      reset(){
        Object.assign(this.$data, this.$options.data.apply(this));
      },
    }
  }
</script>

<style scoped>
#cont {
padding: 70px;
}
#form {
  background-color: #ff9d76;
  color:brown;
}
.imagearea{
        justify-content: center;
        max-width: 500px;
        height: 300px;
        border: hidden;
        margin: auto;
        background-color: #fb3569;
    }

    [v-cloak]{
      display:none;
    }
    

</style>
